<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: ChangeLog</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="changes">ChangeLog </a></h1><ul>
<li>
<p class="startli"><b>version 0.9 (3061) - April 20, 2010</b><br/>
</p>
<ul>
<li>added Rok Dittrich's demag energy and demag factor calculator for regular prisms: <a class="el" href="demagcalc.html#s_demagcalc">Calculator for the magnetostatic energy and demagnetizing factor of a uniformly magnetized ferromagnetic prism</a> (2586)</li>
<li>appended suffix to all scripts, e.g. .py, .sh, .awk - helps Windows users (2618)</li>
<li>new command line option -condinp_file_t_ns (<a class="el" href="allopttxt.html">allopt.txt</a>) implemented in <a class="el" href="checkiterationllg_8c.html">checkiterationllg.c</a> (2535,2544)</li>
<li>lock magnetization with alpha=999 in <a class="el" href="input.html#project_krn">project.krn: material properties</a> (2540)</li>
<li>deactivated mesh partitioning, activated bandwidth optimization by default (2401,2471,2475)</li>
<li>fixed problem where magpar exits too early when hstepfile is used - thanks to a bug report by Dr. Han (2521)</li>
<li>added Stefan Tibus's new <a class="el" href="tools.html#msh2inp">gmsh: msh2inp.awk</a> (implemented in awk) (2538)</li>
<li>replaced calls to Metis functions by new implementations: <a class="el" href="mesh2dual_8c.html#abb99aec57817a85ad1c4c2552f695434">Mesh2Nodal()</a>, <a class="el" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual()</a> (this removes magpar's dependency on Metis - unless mesh partitioning is used) (2674)</li>
<li>magpar runs in parallel also on Windows: <a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a> (2696,2712)</li>
<li>new implementation of Karlqvist head field (<a class="el" href="hext__kq_8c.html">hext_kq.c</a>) contributed by Josephat Kalezhi (3001-3004,3008,3024)</li>
<li>new -magdist_llg, -magdist_ns options (add_allopt_txt) (2980)</li>
<li>added example material parameters to <a class="el" href="input.html#project_krn">project.krn: material properties</a> (2973, 3029)</li>
<li>revised makefiles: split Makefile and separated out Makefile.devel (3021,3026)</li>
<li>update and default to PETSc version 3.0.0 and TAO 1.10 (2706,2711)</li>
<li>removed support for PETSc versions older than 2.3.3 (2400)</li>
<li>removed support for SUNDIALS versions older than 2.3.0 (2400)</li>
<li>removed support for BlockSolve (PETSc 3.1 removed BlockSolve interface)</li>
<li>update for new default library versions: PETSc 3.0.0-p12 (3015), TAO 1.10-p1 (2890), LAPACK 3.2.1, MPICH2 1.2.1p1 (3009), zlib 1.2.4 (3009, 3016), libpng 1.4.1 (3016), ParMetis 3.1.1 (2559)</li>
<li>preparations for PETSc 3.1 (still waiting for TAO update) (3014)</li>
<li>new targets in Makefile.libs to simplify <a class="el" href="faq.html#mingw_compile">Compiling magpar using the MinGW compilers in Cygwin</a> (3038,3041,3048)</li>
<li>added options for downloading, compiling, activating hypre in <a class="el" href="PETSc-config-magpar_8py.html">PETSc-config-magpar.py</a> (inactive by default) (2519)</li>
<li>improvements to the initialization routines, which can reduce the setup time and memory requirements for large models significantly, especially matrix preallocation for the field matrices and in <a class="el" href="init_8h.html#ab880c52c1f93378088ef1e53763aa916">facnb.c::FacNB</a> (2562,2564,2571,2583,2585,2697)</li>
<li>various improvements, fixes to documentation, e.g. "Physical Volumes" in Gmsh models (.geo files) have to start with 1 (<a class="el" href="preprocessing.html#gmsh">Gmsh</a>); reported by Rajmani Gaur - thanks! (2633); <a href="http://www.magpar.net/InstallationOnSolarisSPARC">InstallationOnSolarisSPARC</a> described by Stefan Tibus (2770)</li>
<li>updated list of <a class="el" href="publications.html">Publications</a> (2705,2708,2984,2926,2959,2998,3031-3036,3043-3047,3050,3052,3053)</li>
<li>version 0.9rc2 (2916) 2009-12-09</li>
<li>version 0.9rc1 (2735) 2009-08-20</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.8 (2383) - Dec. 14, 2008</b><br/>
</p>
<ul>
<li>revised <a class="el" href="makefiles.html">Makefile system</a> (1148,1187,1263-1267,1839,2002,2004)</li>
<li>updated documentation, added call and caller graphs (e.g. see <a class="el" href="main_8c.html">main.c</a>), manual in <a href="../magpar.pdf">PDF format</a>, fixed and updated links (1151,1383,1362,1539,1554)</li>
<li>updated list of <a class="el" href="publications.html">Publications</a> (1689,1980,2314,2360), new sections in <a class="el" href="faq.html">FAQ</a> : <a class="el" href="faq.html#win32_run">Running magpar on Windows</a>, <a class="el" href="faq.html#bmatsize">How does boundary matrix size scale with mesh length?</a>, <a class="el" href="faq.html#barycentric">Interpolating in a tetrahedral mesh with barycentric coordinates</a> (1617,1814)</li>
<li>added section on MagParExt, the magpar <a class="el" href="faq.html#gui">Graphical User Interface for Windows</a> developed by Tomasz Blachowicz and Bartlomiej Baron (1595,1597)</li>
<li>added section on <a class="el" href="faq.html#mingw_compile">Compiling magpar using the MinGW compilers in Cygwin</a> (2271,2322,2327,2338)</li>
<li>fixed field sweep implementation (thanks to patches by Stefan Tibus, Univ. of Konstanz) (1153); use "-tol 0" with field sweep! (1165)</li>
<li>new option -condinp_equil_j (<a class="el" href="allopttxt.html">allopt.txt</a>) implemented by Stefan Tibus (1690)</li>
<li>new option -hext_ho_hstepfile (<a class="el" href="allopttxt.html">allopt.txt</a>) implemented by Stefan Tibus (1691)</li>
<li>various fixes and speedups for initialization of exchange and anisotropy field, calculate energy density, average magnetization based on magnetic volume so airboxes do not skew it (1158,1170,1262,2128,2169,2242)</li>
<li>speed up boundary matrix calculation, separated out function <a class="el" href="bele_8c.html">bele.c</a> to calculate contributions to individual matrix elements (1203,1940)</li>
<li>set new defaults for TAO options (2310,2326) - see <a class="el" href="allopttxt.html">allopt.txt</a> ; implemented new convergence test for energy minimization (2284)</li>
<li>added inp2vt converters from Stefan Tibus (<a class="el" href="tools.html#vtk">vtk tools</a>) (1430)</li>
<li>fixed png output to honor option -res again (1225)</li>
<li>fixed png output to take cut at the correct position (1226,1233,1246)</li>
<li>added second png slice output (see <a class="el" href="writedatapng2_8c.html">writedatapng2.c</a> and <a class="el" href="allopttxt.html">allopt.txt</a>) (1414)</li>
<li>fixed problems with demag field calculation in certain geometries/FE meshes: fix suggested by Hiroki Kobayashi, Fujitsu (1408)</li>
<li>added <a class="el" href="bug.html#programming_general">General programming guidelines</a> section to <a class="el" href="bug.html">Programming, Debugging, Bug Reporting</a> (1407)</li>
<li>update for latest library versions (libpng, petsc, mvapich2, parmetis) (1405,1424,1428,1739,1933,2220,2311,2367); (override settings as shown in <a class="el" href="makefiles.html#makefiles_Makefile_in_host_oldlibs">Makefile.in.host_oldlibs</a> to continue using older library versions)</li>
<li>fixed "-init_mag 12": head-to-head transverse domain wall with transition region (1425)</li>
<li>added "-init_mag 13": head-to-head vortex wall (1569)</li>
<li>updated <a class="el" href="bug.html">Programming, Debugging, Bug Reporting</a> page (1454)</li>
<li>fixed run modes 2,3 (<a class="el" href="allopttxt.html">allopt.txt</a>) (1459,1461)</li>
<li>changed default divtol for psolve KSP to 100 (1503)</li>
<li>checked magpar with <a href="http://valgrind.org/">Valgrind</a> for memory corruption</li>
<li>version 0.8pre4 (1729) 2008-08-20</li>
<li>version 0.8pre3 (1568) 2008-07-18</li>
<li>version 0.8pre2 (1320) 2008-02-20</li>
<li>version 0.8pre1 (1315) 2008-02-20</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.7 (1145)- Nov. 2, 2007</b><br/>
</p>
<ul>
<li>update for PETSc version 2.3.3 (requires TAO 1.9)</li>
<li>update for PETSc version 2.3.2 (requires TAO 1.8.2)</li>
<li>dropped support for PETSc version 2.1.6 and earlier (i.e. version 2.2.0 or later required)</li>
<li>update for SUNDIALS version 2.3.0</li>
<li>dropped support for SUNDIALS versions before 2.1.0</li>
<li>SUNDIALS/PVode saves its information in a separate log file <a class="el" href="output.html#project_log_pvode">project.log_pvode</a></li>
<li>improved <a class="el" href="makefiles.html">Makefile system</a>, updated <a class="el" href="install.html">Installation</a> instructions</li>
<li>created new Makefile.in.tmpl for machine specific settings (cf. <a class="el" href="install.html#c_magpar">magpar</a>)</li>
<li>created new <a class="el" href="makefiles.html#makefiles_Makefile_libs">Makefile.libs</a> for automatic download, configuration, compilation, installation of all libraries</li>
<li>new import filter <a class="el" href="tools.html#gmshtoucd">gmsh: gmshtoucd.py</a> for <a class="el" href="preprocessing.html#gmsh">Gmsh</a> finite element meshes</li>
<li>new <a class="el" href="postprocessing.html#opendx">OpenDX</a> tools: inp2dx converter and visual program</li>
<li>moved all tools to src/tools/</li>
<li>updated example <a class="el" href="examples.html#sphere_larmor">sphere_larmor: Larmor precession</a> and added example <a class="el" href="examples.html#mumag3b">mumag3b: mumag standard problem #3 with 2 cubes</a> with <a class="el" href="preprocessing.html#gmsh">Gmsh</a> geometry and mesh files</li>
<li>updated implementation of magnetoelastic effects and accompanying example <a class="el" href="examples.html#magnetoelastic">stress: Magnetoelastic effects on domain structure</a> (originally implemented by Ahmet Kaya from the research group of <a href="http://www.ece.cmu.edu/~jbain/">Jim Bain</a> and <a href="http://www.ece.cmu.edu/~jzhu/">Jimmy Zhu</a> at the <a href="http://www.dssc.ece.cmu.edu/">Data Storage Systems Center (DSSC)</a> at <a href="http://www.cmu.edu/index.shtml">Carnegie Mellon University</a>)</li>
<li>all magpar options now have (reasonably sane) default values if not defined (complete list and defaults given in <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> )</li>
<li>all external fields are now added up in <a class="el" href="hexternal_8c.html">hexternal.c</a>, so different implementations can be active at the same time</li>
<li>source code restructured and cleaned up: renamed files (e.g. hexternalcust.c is now <a class="el" href="hext__cu_8c.html">hext_cu.c</a>, moved code around, combined/removed some files; this wil likely break any third party extensions (e.g. hexternalcust.c, etc. - please contact me if you need help porting your extensions to this new magpar version).</li>
<li>reduced number of global variables (reduced size of struct <a class="el" href="structGridData.html">GridData</a>) by using more local and static variables</li>
<li>removed (incomplete) implementation of periodic boundary conditions</li>
<li>automated regression testing using standard examples</li>
<li>simplified input files for examples, added sample output files</li>
<li>added new simulation modes (2,3) (check <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> for details)</li>
<li>new options (check <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> for details) :<ul>
<li>-mesh_scale</li>
<li>-shift</li>
<li>-optimizebw</li>
<li>-metispartition</li>
<li>-nsliceprop{ser,par}</li>
<li>-mode 99</li>
<li>-hdemag_u{1,2}_ksp_type</li>
<li>-helastic_propfile</li>
<li>-hext_cu</li>
<li>-logpid</li>
<li>-psolve_ksp_*</li>
<li>-ts_logsteps</li>
<li>-ts_nsteps</li>
</ul>
</li>
<li>removed several options (check <a class="el" href="allopttxt.html#allopt_ret_txt">allopt_ret.txt</a>)</li>
<li>renamed magpar executable magpar.exe (instead of magpar.{O,g}_c++)</li>
<li>new version of <a class="el" href="tools.html#ngtoucd">ngtoucd.py</a> (which recognizes several top-level-objects and assigns them different property ids) contributed by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a></li>
<li>version 0.7pre4 (1131) 2007-10-26</li>
<li>version 0.7pre3 (951) 2007-09-20</li>
<li>version 0.7pre2 (754) 2007-07-20</li>
<li>version 0.7pre1 (735) 2007-07-12</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.6 - (private release)</b><br/>
</p>
<ul>
<li>added magnetoelastic effects and accompanying example <a class="el" href="examples.html#magnetoelastic">stress: Magnetoelastic effects on domain structure</a> implemented by Ahmet Kaya</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.5 (629) - Oct. 29, 2005</b><br/>
</p>
<ul>
<li>update for PETSc version 2.3.0 (recommended but not required)</li>
<li>in turn, PETSc 2.3.0 requires the new TAO release 1.8 (cf. <a class="el" href="install.html">Installation</a>)</li>
<li>speedup of about a factor of 2 (!) with PETSc 2.3.0 in parallel simulations</li>
<li>update for SUNDIALS version 2.1.0 (completely new API); magpar is NOT compatible with SUNDIALS version 2.0, but it is still backward compatible with SUNDIALS 1.0 (March 9, 2004 or earlier)!</li>
<li>added cubic anisotropy (implemented by <a href="http://www.parker9.com">Greg Parker</a>)</li>
<li>expanded format of <a class="el" href="input.html#project_krn">project.krn: material properties</a> for third Euler angle for cubic anisotropy</li>
<li>added example for cubic anisotropy: <a class="el" href="examples.html#sphere_cubic">sphere_cubic: Single domain particle with cubic anisotropy</a></li>
<li>added K_2 term to uniaxial anisotropy (implemented by <a href="http://www.parker9.com">Greg Parker</a>)</li>
<li>storing data of the external field in <a class="el" href="output.html#project_gz">project.INP.gz</a></li>
<li>magpar has been successfully compiled and run on Mac OS X: <a class="el" href="faq.html#macosx">Apple Macintosh running Mac OS X</a> (thanks to <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> and <a href="http://www.parker9.com">Greg Parker</a>)</li>
<li>update for <a class="el" href="faq.html#singleproc">Single processor version without MPI</a></li>
<li>update for <a class="el" href="faq.html#win32_compile">Compiling magpar in Cygwin for Windows</a></li>
<li>magpar executables for Windows are available on the <a href="http://www.magpar.net/">magpar homepage</a>.</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.4 (383) - March 16, 2005</b><br/>
</p>
<ul>
<li>update for PETSc version 2.2.1 (recommended but not required), patch by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a></li>
<li>in turn, PETSc 2.2.1 requires the new TAO release 1.7 (cf. <a class="el" href="install.html">Installation</a>)</li>
<li>please upgrade to PETSc version 2.2.1 and TAO 1.7: support for older versions of PETSc (&lt;2.2.1) will be dropped in the next release (to make maintenance of the code easier)</li>
<li>use analytical formula for stiffness matrix elements of anisotropy field (cf. stiffmat.c )</li>
<li>changed format of <a class="el" href="input.html#project_krn">project.krn: material properties</a> file: added one column for damping constant, which can now be defined individually for each grain/part of the model (implemented upon request by <a href="http://magnet.ap.columbia.edu/">Bill Bailey</a>)</li>
<li>thus, removed option "-alpha" from <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a></li>
<li>symmetrized stiffness matrices for magnetostatic field</li>
<li>thus, CG solver with ICC preconditioning can be used (update options in your <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> files according to the template <a class="el" href="allopttxt.html">allopt.txt</a> and the <a class="el" href="examples.html">Examples</a>!)</li>
<li>added new options for user defined selection of linear solver in psolve: "-psolve_*" (cf. <a class="el" href="allopttxt.html">allopt.txt</a>)</li>
<li>update for <a class="el" href="faq.html#amd64">64-bit Linux</a> (patch by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a>)</li>
<li>removed dependency on cblas, updated <a class="el" href="install.html">Installation</a> instructions</li>
<li>added example <a class="el" href="examples.html#thinfilm">thinfilm: Thin magnetic film</a></li>
<li>added <a class="el" href="magconv.html">Magnetic Unit Converter</a> to manual</li>
<li>updated documentation (especially <a class="el" href="install.html">Installation</a>, <a class="el" href="faq.html">FAQ</a>); thanks for many suggestions to Jehyun Lee</li>
<li>added <a class="el" href="tools.html#ngtoucd">ngtoucd.py</a> tool by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> and <a href="http://www.soton.ac.uk/~fangohr/">Hans Fangohr</a> to contrib directory</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.3.1 (187) - Aug. 30, 2004</b><br/>
 one-line bugfix in <a class="el" href="serinit_8c.html">src/init/serinit.c</a>: uninitialized pointer</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.3 (184) - July 21, 2004</b><br/>
</p>
<ul>
<li>update for PETSc version 2.2.0 (not required) <br/>
patches contributed by <a href="http://www.soton.ac.uk/~rpb/">Richard Boardman</a> - thanks!</li>
<li>in turn, PETSc 2.2.0 requires the new TAO release 1.6 (cf. <a class="el" href="install.html">Installation</a>)</li>
<li>update to SUNDIALS version of March 9, 2004 (PVODE unchanged, update not required)</li>
<li>fixed preconditioning for LLG integration with PVODE</li>
<li>removed code for cubic anisotropy</li>
<li>project.krn file format simplified: <br/>
any data after exchange constant are ignored (cf. <a class="el" href="input.html#project_krn">project.krn: material properties</a>)</li>
<li>removed parameters k2 and js from <a class="el" href="input.html#input_allopt_txt">allopt.txt: simulation parameters</a> : <br/>
k2 has not been used <br/>
js only used for internal scaling of magnetization and fields and 1 Tesla should do it anyway, therefore now hardcoded</li>
<li>more verbose output during initialization</li>
<li>updated examples</li>
<li>many code clean-ups</li>
<li>updated and improved documentation</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Jan. 2004</b><br/>
 Presented magpar at the 9th Joint MMM/Intermag Conference, January 5-9, 2004, Anaheim, CA, USA<br/>
 (cf. <a class="el" href="publications.html">Publications</a>)</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.2 (101) - Nov. 13, 2003</b><br/>
</p>
<ul>
<li>use ParMetis 3.1 instead of Metis 4.0</li>
<li>added magdist parameter (small random distortion of magnetization in equilibrium when using energy minimization)</li>
<li>created <a class="el" href="eminisolve_8c.html">eminisolve.c</a> to shrink solve.c</li>
<li>updated documentation: installation, added performance page</li>
<li>fixed several memory allocation problems and memory leaks</li>
<li>created local2global mappings in <a class="el" href="movedata_8c.html">movedata.c</a> (not while reading the mesh)</li>
<li>added some more output after mesh partitioning</li>
</ul>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>version 0.1 (63) - Sept. 12, 2003</b><br/>
 first public release<br/>
 under the terms of the <a href="http://www.gnu.org">GNU</a> <a href="http://www.gnu.org/licenses/gpl.html">General Public License</a></p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Aug. 2003</b><br/>
 started documentation using <a href="http://www.doxygen.org/">Doxygen</a></p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>July 27 - August 1, 2003</b><br/>
 presentation of magpar at the "International Conference on Magnetism 2003" in Rome<br/>
 (cf. <a class="el" href="publications.html">Publications</a>)</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>March 2003</b><br/>
 completed my dissertation "Scalable Parallel Micromagnetic Solvers for Magnetic Nanostructures"<br/>
 (cf. <a class="el" href="publications.html">Publications</a>)</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Jan. 2003</b><br/>
 major restructuring of the source code</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Nov. 2002</b><br/>
 implemented regular mesh refinement</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Oct. 2002</b><br/>
 implemented output of PNG graphics files (magnetization snapshots)</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>Sept. 2002</b><br/>
 implemented static energy minimization</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>summer 2002</b><br/>
 implemented exchange, anisotropy, external, demagnetizing field<br/>
 implemented preconditioned time integration of the dynamic Landau-Lifshitz-Gilbert equation</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><b>early 2002</b><br/>
 evaluated parallel finite element, linear algebra software packages<br/>
 package selection and first implementation of FE solution of Poisson's equation</p>
<p class="endli"></p>
</li>
</ul>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

